//sketch_3D_Graph

String[] lines;
float[][] pieces;
int index = 0;
int Nx,Ny;

float Vmin=1000;//入力最小値
float Vmax=-1000;//入力最小値

void setup()
{
  size(400, 400, P3D);
  colorMode(HSB, 1.2,1.0, 1.0); 
  noStroke();
  lines = loadStrings("data.txt");
  Ny=lines.length;
  pieces=new float[Ny][];
  int i,j;
  for(j=0;j<Ny;j++)
  {
    pieces[j] = float(split(lines[j], '\t'));
    Nx=pieces[j].length;
    for(i=0;i<Nx;i++)
    {
       print(pieces[j][i]);print("  ");
       if(i>0 && j>0)
       {
         if(pieces[j][i]<Vmin){Vmin=pieces[j][i];}//最小値設定
         if(pieces[j][i]>Vmax){Vmax=pieces[j][i];}//最大値設定
       }
    }
    println();
  }
  println(Vmin);
  println(Vmax);
}

void draw()
{
  background(0,0,1.0);
  lights();
  ortho();
  translate(width / 2, height / 2);
  rotateY(map(mouseX, 0, width, -PI/1, PI/1));
  rotateX(map(mouseY, 0, height, PI/1, -PI/1));
  //scale(2,2,2);
  int i,j;
  for(i=1;i<Nx-1;i++)
  {
    for(j=1;j<Ny-1;j++)
    {
      element(i,j);
    }
  }
}

void element(int i,int j)
{
  float[] Xc=new float[5];
  float[] Yc=new float[5];
  float[] Zc=new float[5];
  float[] C=new float[5];
  
  float Px=5;//表示Xピッチ
  float Py=-20;//表示Yピッチ（符号反転）
  float Pz=5;//表示Xピッチ
  
  Xc[1]=Px*(i-Nx/2);Xc[2]=Px*(i+1-Nx/2);Xc[3]=Px*(i+1-Nx/2);Xc[4]=Px*(i-Nx/2);Xc[0]=(Xc[1]+Xc[2]+Xc[3]+Xc[4])/4;
  Yc[1]=Py*pieces[j][i];Yc[2]=Py*pieces[j][i+1];Yc[3]=Py*pieces[j+1][i+1];Yc[4]=Py*pieces[j+1][i];Yc[0]=(Yc[1]+Yc[2]+Yc[3]+Yc[4])/4;
  Zc[1]=Pz*(j-Ny/2);Zc[2]=Pz*(j-Ny/2);Zc[3]=Pz*(j+1-Ny/2);Zc[4]=Pz*(j+1-Ny/2);Zc[0]=(Zc[1]+Zc[2]+Zc[3]+Zc[4])/4;
  
  int li;
  for(li=0;li<4;li++)
  {
    if(li==3)
    {
      C[li]=(Yc[0]+Yc[li+1]+Yc[1])/3;
    }
    else
    {
      C[li]=(Yc[0]+Yc[li+1]+Yc[li+2])/3;
    }
  }
  for(li=0;li<4;li++)
  {
    fill(map(C[li], Vmax*(Py), Vmin*(Py), 0, 1), 1.0, 1.0);
    //fill(0.8, 1.0, 1.0);
    beginShape(TRIANGLES);
    vertex(Xc[0],Yc[0],Zc[0]);
    vertex(Xc[li+1],Yc[li+1],Zc[li+1]);
    if(li==3)
    {
      vertex(Xc[1],Yc[1],Zc[1]);
    }
    else
    {
      vertex(Xc[li+2],Yc[li+2],Zc[li+2]);
    }
    endShape(CLOSE);
  }
}

